﻿package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Pixelmask;
	
	public class e_Lava extends Entity
	{
		[Embed(source = 'lava.png')] private const LAVA:Class;
		[Embed(source = 'lava_mask.png')] private const MASK:Class;

		public var speed:Number=0.1;
		public var ref_player:e_Player;
		public var offset:Number=0;
		
		public function e_Lava(p:e_Player) 
		{
			graphic = new Image(LAVA);
			mask = new Pixelmask(MASK);
			x=-800;
			y=-800;
			layer=-3;
			type = "lava";

			ref_player = p;
		}

		override public function update():void 
		{
			x+=speed;
			y+=speed;
			if (collide("player",x,y) && !ref_player.dead) {
				ref_player.dead=true;
				if (speed<5) speed=5;
			}
			if (!onCam()) {
				while (!onCam()) {
					x+=20;
					y+=20;
				}
			}
			if (x>=FP.camera.x || y>=FP.camera.y) {
				x=FP.camera.x;
				y=FP.camera.y;
				speed=0;
				if (!ref_player.dead) ref_player.dead=true;
			} else speed+=0.00015;
			
			if (ref_player.y-offset < ref_player.x) {
				while (ref_player.y-offset < ref_player.x) {
					offset--;
					x+=0.5;
					y-=0.5;
				}
			} else if (ref_player.y-offset > ref_player.x) {
				while (ref_player.y-offset > ref_player.x) {
					offset++;
					x-=0.5;
					y+=0.5;
				}
			}
		}

		public function onCam():Boolean
		{
			return collideRect(x+200, y+200, FP.camera.x, FP.camera.y, FP.width, FP.height);
		}
	}
}
