﻿package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.Sfx;
	import flash.geom.Point;
	
	public class e_Player extends Entity
	{
		[Embed(source = 'sound/rope1.mp3')]		private const R1:Class;
		public var rope1:Sfx				=	new Sfx(R1);
		[Embed(source = 'sound/rope2.mp3')]		private const R2:Class;
		public var rope2:Sfx				=	new Sfx(R2);
		[Embed(source = 'sound/rope3.mp3')]		private const R3:Class;
		public var rope3:Sfx				=	new Sfx(R3);
		[Embed(source = 'sound/rope4.mp3')]		private const R4:Class;
		public var rope4:Sfx				=	new Sfx(R4);
		[Embed(source = 'sound/ropef.mp3')]		private const RF:Class;
		public var ropef:Sfx				=	new Sfx(RF);

		public var r1x:Number=0;
		public var r1y:Number=0;
		public var r1l:Number=1;
		public var r2x:Number=0;
		public var r2y:Number=0;
		public var r2l:Number=1;
		public var rfx:Number=0;
		public var rfy:Number=0;
		public var rft:Number=0;
		
		public var xspeed:Number=0;
		public var yspeed:Number=0;
		public var dead:Boolean=false;
		public var px:Number=0;
		public var py:Number=0;
		
		public function e_Player() 
		{
			x=400;
			y=300;
			
			setHitbox(1,1);
			type="player";
			
			Input.define("Rope1", Key.LEFT, Key.A);
			Input.define("Rope2", Key.RIGHT, Key.D);
		}

		override public function update():void 
		{
			/*var l:e_Lava = collide("lava",x,y) as e_Lava;
			if (l) {
				dead=true;
				if (l.speed<5) l.speed=5;
			}*/

			if (!dead) {	
				if (rft>0) rft--;
				else {
					rfx=0;
					rfy=0;
				}
				if (r1l<1) {
					r1l+=0.2;
					if (r1l>=1) {
						var xs:Number=r1x-x;
						var ys:Number=r1y-y;
						xs = xs*0.01;
						ys = ys*0.01;
						for (var i:Number=0;i<=10;i++) {
							FP.world.add(new e_Particle(r1x,r1y,xs+(Math.random()*2-1),ys+(Math.random()*2-1),0x666666));
						}
						var snum:Number=4;
						var s:Number=Math.round(Math.random()*snum);
						if (s==0 || s==snum) rope1.play();
						else if (s==1) rope2.play();
						else if (s==2) rope3.play();
						else if (s==3) rope4.play();
					}
				}
				if (r2l<1) {
					r2l+=0.2;
					if (r2l>=1) {
						var xs:Number=r2x-x;
						var ys:Number=r2y-y;
						xs = xs*0.01;
						ys = ys*0.01;
						for (var i:Number=0;i<=10;i++) {
							FP.world.add(new e_Particle(r2x,r2y,xs+(Math.random()*2-1),ys+(Math.random()*2-1),0x3333FF));
						}
						var snum:Number=4;
						var s:Number=Math.round(Math.random()*snum);
						if (s==0 || s==snum) rope1.play();
						else if (s==1) rope2.play();
						else if (s==2) rope3.play();
						else if (s==3) rope4.play();
					}
				}

				if (Input.pressed("Rope1")) {
					var p:Point = new Point();
					var mx:Number = FP.camera.x+Input.mouseX;
					var my:Number = FP.camera.y+Input.mouseY;
					while (distanceToPoint(mx,my)<1000) {
						mx+=mx-x;
						my+=my-y;
					}
					var w:e_Wall = FP.world.collideLine("wall",x,y,mx,my,1,p) as e_Wall;
					if (w) {
						if (!w.b && p.x >= FP.camera.x-200 && p.y >= FP.camera.y-400 && p.x <= FP.camera.x+1000 && p.y <= FP.camera.y+1000) {
							r1x=p.x;
							r1y=p.y;
							r1l=0.1;
						} else {
							rfx=p.x;
							rfy=p.y;
							rft=15;
							ropef.play();
						}
					} else {
						rfx=mx;
						rfy=my;
						rft=15;
						ropef.play();
					}
				}
				if (Input.pressed("Rope2")) {
					var p:Point = new Point();
					var mx:Number = FP.camera.x+Input.mouseX;
					var my:Number = FP.camera.y+Input.mouseY;
					while (distanceToPoint(mx,my)<1000) {
						mx+=mx-x;
						my+=my-y;
					}
					var w:e_Wall = FP.world.collideLine("wall",x,y,mx,my,1,p) as e_Wall;
					if (w) {
						if (!w.b && p.x >= FP.camera.x-200 && p.y >= FP.camera.y-400 && p.x <= FP.camera.x+1000 && p.y <= FP.camera.y+1000) {
							r2x=p.x;
							r2y=p.y;
							r2l=0.1;
						} else {
							rfx=p.x;
							rfy=p.y;
							rft=15;
							ropef.play();
						}
					} else {
						rfx=mx;
						rfy=my;
						rft=15;
						ropef.play();
					}
				}
			
				if ((r1x>0 || r1y>0) && (r2x>0 || r2y>0)) {
					var factor:Number = 0.01;
					var destx:Number = (r1x+r2x)/2;
					var desty:Number = (r1y+r2y)/2;
					if (distanceToPoint(destx,desty)>3) {
						xspeed += (destx-x)*factor;
						yspeed += (desty-y)*factor;
						if (Math.abs(xspeed)>15 || Math.abs(yspeed)>15) {
							if (Math.abs(xspeed)>Math.abs(yspeed)) {
								yspeed = (15/Math.abs(xspeed))*yspeed;
								xspeed = FP.clamp(xspeed,-15,15);
							} else {
								xspeed = (15/Math.abs(yspeed))*xspeed;
								yspeed = FP.clamp(yspeed,-15,15);
							}
						}
						factor = distanceToPoint(destx,y)/50;
						if (factor>1) factor=1;
						if (factor<0.3 && factor!=0) factor=0.3;
						var tx:Number = x + xspeed * factor;
						if (distanceToPoint(destx,y)<5) {
							tx=destx;
							xspeed=0;
						}
						factor = distanceToPoint(x,desty)/50;
						if (factor>1) factor=1;
						if (factor<0.3 && factor!=0) factor=0.3;
						var ty:Number = y + yspeed * factor;
						if (distanceToPoint(x,desty)<5) {
							ty=desty;
							yspeed=0;
						}
						//if (distanceToPoint(destx,desty)>15*factor) moveTowards(destx,desty,15*factor);
						moveTo(tx,ty,"wall",true);
					} else {
						xspeed=0;
						yspeed=0;
						x=destx;
						y=desty;
					}
				}
				if (x!=px || y!=py) {
					FP.world.add(new e_Particle(px,py,0,0,0x000000,15));
					FP.world.add(new e_Particle((px+x)/2,(py+y)/2,0,0,0x000000,15));
					px = x;
					py = y;
				}
			}
		}
		
		override public function render():void 
		{
			if (r1x>0 || r1y>0) {
				if (r1l>=1) Draw.linePlus(x,y,r1x,r1y,0x000000,1,5);
				else {
					var w:Number=r1x-x;
					var h:Number=r1y-y;
					w = w*r1l;
					h = h*r1l;
					Draw.linePlus(x,y,x+w,y+h,0x000000,1,5);
				}
			}
			if (r2x>0 || r2y>0) {
				if (r2l>=1) Draw.linePlus(x,y,r2x,r2y,0x0000CC,1,5);
				else {
					var w:Number=r2x-x;
					var h:Number=r2y-y;
					w = w*r2l;
					h = h*r2l;
					Draw.linePlus(x,y,x+w,y+h,0x0000CC,1,5);
				}
			}
			if (rfx>0 || rfy>0) Draw.linePlus(x,y,rfx,rfy,0xFF0000,0.5,3);
			if (!dead) Draw.circlePlus(x,y,15,0x000000);
			else Draw.circlePlus(x,y,15,0xFF0000,0.5);
		}
		
		override public function moveCollideX(e:Entity):void
		{
			xspeed=0;
		}
		override public function moveCollideY(e:Entity):void
		{
			yspeed=0;
		}
	}
}
