package
{
	import net.flashpunk.*;
	import net.flashpunk.graphics.*;
	import net.flashpunk.utils.*;
	
	import flash.display.LoaderInfo;
	import flash.utils.getDefinitionByName;

	public class Preloader extends World
	{
		private var text: Text;
		
		private var nextClassName: String;
		
		private var mustClick: Boolean = false;
		
		public function Preloader (_next: String)
		{
			nextClassName = _next;
			
			text = new Text("LOADING... 0%", 400, 260, 300);
			
			text.x = 400 - text.width * 0.5;
		}

		public override function update (): void
		{
			if (hasLoaded())
			{
				if (mustClick) {
					if (Input.pressed(Key.SPACE)) {
						startup();
					}
				} else {
					startup();
				}
			}
		}
		
		public override function render (): void
		{
			if (hasLoaded())
			{
				text.scale = 1;
				
				text.text = "WARNING!\nThis game is running on a site without permission to host it.\nYou will not be able to view Intro/Outro\nand you can't use the Online Highscores. Play the game at greencouchgames.net\nPress Space.";
				
				text.x = 400 - text.width * text.scale * 0.5;
				text.y = 300 - text.height * text.scale * 0.5;
			}
			else
			{
				FP.rect.x = 68;
				FP.rect.y = 228;
				FP.rect.width = 504;
				FP.rect.height = 24;
				
				FP.buffer.fillRect(FP.rect, 0xFFFFFFFF);
				
				var p:Number = (this.loaderInfo.bytesLoaded / this.loaderInfo.bytesTotal);
				
				FP.rect.x = 100;
				FP.rect.y = 450;
				FP.rect.width = p * 600;
				FP.rect.height = 20;
				
				FP.buffer.fillRect(FP.rect, 0xFF000000);
				
				text.text = "LOADING... " + int(p * 100) + "%";
			}
			
			FP.point.x = 0;
			FP.point.y = 0;
			text.render(FP.buffer, FP.point, FP.camera);
		}
		
		private function hasLoaded (): Boolean {
			return (FP.stage.loaderInfo.bytesLoaded >= FP.stage.loaderInfo.bytesTotal);
		}
		
		private function startup (): void
		{
	//		var mainClass:Class = getDefinitionByName(nextClassName) as Class;
			
			FP.world = new l_Game;
		}
		
		private function get loaderInfo (): LoaderInfo
		{
			return FP.engine.loaderInfo;
		}
	}
}