﻿package  
{
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Backdrop;
	import flash.geom.Point;
	
	public class l_Game extends World
	{	
		[Embed(source = 'sound/far.mp3')]		private const F:Class;
		public var msc_f:Sfx				=	new Sfx(F);
		[Embed(source = 'sound/close.mp3')]		private const C:Class;
		public var msc_c:Sfx				=	new Sfx(C);
		[Embed(source = 'sound/dead.mp3')]		private const D:Class;
		public var msc_d:Sfx				=	new Sfx(D);

		[Embed(source = 'eyecandy.png')] private const BG:Class;

		public var vertical:Boolean = false;
		public var verticam:Boolean = false;
		public var screen:Point = new Point();
		public var pscreen:Point = new Point();
		public var screennum:Number = 0;
		public var visitedscreens:Array = new Array();
		
		public var ref_player:e_Player;
		public var ref_lava:e_Lava;
		public var bdrop1:Backdrop;
		public var bdrop2:Backdrop;
		
		public function l_Game() 
		{	
			FP.screen.color = 0xFFFFFF;
			bdrop1 = new Backdrop(BG);
			bdrop1.scrollX=0.5;
			bdrop1.scrollY=0.5;
			bdrop1.alpha=0.5;
			addGraphic(bdrop1);
			bdrop2 = new Backdrop(BG);
			bdrop2.scrollX=0.75;
			bdrop2.scrollY=0.75;
			bdrop2.alpha=1;
			bdrop2.x=250;
			bdrop2.y=250;
			addGraphic(bdrop2);

			add(new e_Wall(0,0,800,100,false));
			add(new e_Wall(0,500,800,100,false));
			add(new e_Wall(800,0,800,100,false));
			add(new e_Wall(800,500,800,100,false));
			add(new e_Wall(1600,0,800,100,false));
			add(new e_Wall(1600,500,800,100,false));
			/*OUT*/ add(new e_Wall(0,-600,800,600,false));
			/*OUT*/ add(new e_Wall(0,600,800,600,false));
			/*OUT*/ add(new e_Wall(800,-600,800,600,false));
			/*OUT*/ add(new e_Wall(800,600,800,600,false));
			/*OUT*/ add(new e_Wall(1600,-600,800,600,false));
			/*OUT*/ add(new e_Wall(1600,600,800,600,false));

			ref_player = add(new e_Player()) as e_Player;
			ref_lava = add(new e_Lava(ref_player)) as e_Lava;
			screen.x=3;
			screen.y=0;
			pscreen.x=0;
			pscreen.y=0;
			visitedscreens.push(new Point(0,0));

			msc_c.loop();
			msc_c.volume=0.5;
			msc_f.loop();

			add(new e_Fadein());
		}
		
		public override function update():void
		{
			super.update();
			bdrop1.x+=0.5;
			bdrop2.x+=0.25;
			
			if (verticam) {
				FP.camera.x = inScreen().x*800;
				var tempy:Number = ref_player.y-300;
				if (tempy > FP.camera.y) FP.camera.y = tempy;
				if (ref_player.x - FP.camera.x > 650) verticam=false;
			} else {
				var tempx:Number = ref_player.x-400;
				if (tempx > FP.camera.x) FP.camera.x = tempx;
				FP.camera.y = inScreen().y*600;
				if (ref_player.y - FP.camera.y > 500) verticam=true;
			}

			if (ref_player.dead && FP.world.classCount(e_Score)==0) {
				add(new e_Score(screennum,FP.camera.x+25,FP.camera.y+26,visitedscreens,inScreen(),pscreen));
				add(new e_End(FP.camera.x+75,FP.camera.y+534,screennum));
				msc_d.play();
				msc_c.volume=0;
				msc_f.volume=0;
			}
			if (!ref_player.dead) {
				if (ref_player.distanceFrom(ref_lava)<1400) msc_c.volume=1;
				else if (ref_player.distanceFrom(ref_lava)>1700) msc_c.volume=0;
				else msc_c.volume=(FP.clamp(ref_player.distanceFrom(ref_lava),1400,1700)-1700)/-300;
			}

			if (pscreen.x + pscreen.y < inScreen().x + inScreen().y) {
				screennum++;
				visitedscreens.push(inScreen());
				if (!vertical) {
					var p:Number=Math.round(Math.random());
					if (p==0) {
						var onum:Number=8;
						var o:Number=Math.round(Math.random()*onum);
						if (o==0 || o==onum) {
							add(new e_Wall(screen.x*800+200,screen.y*600+0,175,125,true));
							add(new e_Wall(screen.x*800+200,screen.y*600+475,175,125,true));
							add(new e_Wall(screen.x*800+425,screen.y*600+0,175,125,true));
							add(new e_Wall(screen.x*800+425,screen.y*600+475,175,125,true));
						} else if (o==1) {
							add(new e_Wall(screen.x*800+200,screen.y*600+450,100,50,true));
							add(new e_Wall(screen.x*800+350,screen.y*600+450,100,50,true));
							add(new e_Wall(screen.x*800+500,screen.y*600+450,100,50,true));
						} else if (o==2) {
							add(new e_Wall(screen.x*800+400,screen.y*600+175,50,200,true));
							add(new e_Wall(screen.x*800+100,screen.y*600+100,50,50,true));
							add(new e_Wall(screen.x*800+650,screen.y*600+100,50,50,true));
							add(new e_Wall(screen.x*800+100,screen.y*600+450,50,50,true));
							add(new e_Wall(screen.x*800+650,screen.y*600+450,50,50,true));
						} else if (o==3) {
							add(new e_Wall(screen.x*800+675,screen.y*600+100,25,200,true));
							add(new e_Wall(screen.x*800+100,screen.y*600+100,25,200,true));
							add(new e_Wall(screen.x*800+375,screen.y*600+250,50,250,true));
						} else if (o==4) {
							add(new e_Wall(screen.x*800+375,screen.y*600+275,50,50,true));
							add(new e_Wall(screen.x*800+625,screen.y*600+425,50,50,true));
							add(new e_Wall(screen.x*800+625,screen.y*600+275,50,50,true));
							add(new e_Wall(screen.x*800+125,screen.y*600+275,50,50,true));
							add(new e_Wall(screen.x*800+125,screen.y*600+125,50,50,true));
						} else if (o==5) {
							add(new e_Wall(screen.x*800+300,screen.y*600+150,200,50,true));
							add(new e_Wall(screen.x*800+550,screen.y*600+300,50,150,true));
							add(new e_Wall(screen.x*800+200,screen.y*600+300,50,150,true));
						} else if (o==6) {
							add(new e_Wall(screen.x*800+300,screen.y*600+400,200,50,true));
							add(new e_Wall(screen.x*800+550,screen.y*600+150,50,150,true));
							add(new e_Wall(screen.x*800+200,screen.y*600+150,50,150,true));
						} else if (o==7) {
							add(new e_Wall(screen.x*800+325,screen.y*600+475,150,25,true));
							add(new e_Wall(screen.x*800+325,screen.y*600+100,150,25,true));
							add(new e_Wall(screen.x*800+700,screen.y*600+200,50,200,true));
							add(new e_Wall(screen.x*800+50,screen.y*600+200,50,200,true));
						}
						add(new e_Wall(screen.x*800+0,screen.y*600+0,800,100,false));
						add(new e_Wall(screen.x*800+0,screen.y*600+500,800,200,false));
						/*OUT*/ add(new e_Wall(screen.x*800+0,screen.y*600-600,800,600,false));
						/*OUT*/ add(new e_Wall(screen.x*800+0,screen.y*600+600,800,600,false));
						screen.x++;
					} else {
						var onum:Number=6;
						var o:Number=Math.round(Math.random()*onum);
						if (o==0 || o==onum) {
							add(new e_Wall(screen.x*800+100,screen.y*600+350,200,200,true));
						} else if (o==1) {
							add(new e_Wall(screen.x*800+450,screen.y*600+100,200,200,true));
						} else if (o==2) {
							add(new e_Wall(screen.x*800+150,screen.y*600+500,25,100,true));
							add(new e_Wall(screen.x*800+0,screen.y*600+475,175,25,true));
						} else if (o==3) {
							add(new e_Wall(screen.x*800+50,screen.y*600+100,400,25,true));
						} else if (o==4) {
							add(new e_Wall(screen.x*800+350,screen.y*600+250,100,100,true));
						} else if (o==5) {
							add(new e_Wall(screen.x*800+150,screen.y*600+100,50,150,true));
							add(new e_Wall(screen.x*800+500,screen.y*600+450,150,50,true));
						}
						add(new e_Wall(screen.x*800+0,screen.y*600+0,800,100,false));
						add(new e_Wall(screen.x*800+0,screen.y*600+500,150,100,false));
						add(new e_Wall(screen.x*800+650,screen.y*600+100,150,500,false));
						/*OUT*/ add(new e_Wall(screen.x*800+0,screen.y*600-600,800,600,false));
						/*OUT*/ add(new e_Wall(screen.x*800+800,screen.y*600-600,800,600,false));
						/*OUT*/ add(new e_Wall(screen.x*800+800,screen.y*600+0,800,600,false));
						screen.y++;
						vertical=true;
					}
				} else {
					var p:Number=Math.round(Math.random());
					if (p==0) {
						var onum:Number=10;
						var o:Number=Math.round(Math.random()*onum);
						if (o==0 || o==onum) {
							add(new e_Wall(screen.x*800+250,screen.y*600+200,300,10,true));
							add(new e_Wall(screen.x*800+250,screen.y*600+400,300,10,true));
						} else if (o==1) {
							add(new e_Wall(screen.x*800+150,screen.y*600+100,300,50,true));
							add(new e_Wall(screen.x*800+350,screen.y*600+300,300,50,true));
							add(new e_Wall(screen.x*800+150,screen.y*600+500,300,50,true));
						} else if (o==2) {
							add(new e_Wall(screen.x*800+350,screen.y*600+200,100,200,true));
						} else if (o==3) {
							add(new e_Wall(screen.x*800+375,screen.y*600+275,50,50,true));
							add(new e_Wall(screen.x*800+200,screen.y*600+100,50,50,true));
							add(new e_Wall(screen.x*800+550,screen.y*600+100,50,50,true));
							add(new e_Wall(screen.x*800+200,screen.y*600+450,50,50,true));
							add(new e_Wall(screen.x*800+550,screen.y*600+450,50,50,true));
						} else if (o==4) {
							add(new e_Wall(screen.x*800+550,screen.y*600+450,50,50,true));
							add(new e_Wall(screen.x*800+450,screen.y*600+350,50,50,true));
							add(new e_Wall(screen.x*800+300,screen.y*600+200,50,50,true));
							add(new e_Wall(screen.x*800+200,screen.y*600+100,50,50,true));
						} else if (o==5) {
							add(new e_Wall(screen.x*800+200,screen.y*600+450,50,50,true));
							add(new e_Wall(screen.x*800+300,screen.y*600+350,50,50,true));
							add(new e_Wall(screen.x*800+450,screen.y*600+200,50,50,true));
							add(new e_Wall(screen.x*800+550,screen.y*600+100,50,50,true));
						} else if (o==6) {
							add(new e_Wall(screen.x*800+550,screen.y*600+275,100,50,true));
							add(new e_Wall(screen.x*800+150,screen.y*600+275,100,50,true));
						} else if (o==7) {
							add(new e_Wall(screen.x*800+275,screen.y*600+275,25,50,true));
							add(new e_Wall(screen.x*800+250,screen.y*600+250,25,100,true));
							add(new e_Wall(screen.x*800+225,screen.y*600+225,25,150,true));
							add(new e_Wall(screen.x*800+200,screen.y*600+200,25,200,true));
							add(new e_Wall(screen.x*800+500,screen.y*600+275,25,50,true));
							add(new e_Wall(screen.x*800+525,screen.y*600+250,25,100,true));
							add(new e_Wall(screen.x*800+575,screen.y*600+200,25,200,true));
							add(new e_Wall(screen.x*800+550,screen.y*600+225,25,150,true));
						} else if (o==8) {
							add(new e_Wall(screen.x*800+625,screen.y*600+350,25,200,true));
							add(new e_Wall(screen.x*800+150,screen.y*600+50,25,200,true));
						} else if (o==9) {
							add(new e_Wall(screen.x*800+150,screen.y*600+350,25,200,true));
							add(new e_Wall(screen.x*800+625,screen.y*600+50,25,200,true));
							add(new e_Wall(screen.x*800+125,screen.y*600+700,0,0,true));
						}
						add(new e_Wall(screen.x*800+0,screen.y*600+0,150,600,false));
						add(new e_Wall(screen.x*800+650,screen.y*600+0,150,600,false));
						/*OUT*/ add(new e_Wall(screen.x*800-800,screen.y*600+0,800,600,false));
						/*OUT*/ add(new e_Wall(screen.x*800+800,screen.y*600+0,800,600,false));
						screen.y++;
					} else if (p==1) {
						var onum:Number=6;
						var o:Number=Math.round(Math.random()*onum);
						if (o==0 || o==onum) {
							add(new e_Wall(screen.x*800+450,screen.y*600+0,100,300,true));
						} else if (o==1) {
							add(new e_Wall(screen.x*800+150,screen.y*600+200,300,300,true));
						} else if (o==2) {
							add(new e_Wall(screen.x*800+450,screen.y*600+250,50,50,true));
							add(new e_Wall(screen.x*800+500,screen.y*600+200,50,50,true));
							add(new e_Wall(screen.x*800+550,screen.y*600+150,50,50,true));
							add(new e_Wall(screen.x*800+600,screen.y*600+100,50,50,true));
						} else if (o==3) {
							add(new e_Wall(screen.x*800+150,screen.y*600+475,600,25,true));
						} else if (o==4) {
							add(new e_Wall(screen.x*800+650,screen.y*600+100,150,25,true));
							add(new e_Wall(screen.x*800+625,screen.y*600+0,25,125,true));
						} else if (o==5) {
							add(new e_Wall(screen.x*800+350,screen.y*600+250,100,100,true));
						}
						add(new e_Wall(screen.x*800+0,screen.y*600+500,800,100,false));
						add(new e_Wall(screen.x*800+650,screen.y*600+0,150,100,false));
						add(new e_Wall(screen.x*800+0,screen.y*600+0,150,500,false));
						/*OUT*/ add(new e_Wall(screen.x*800-800,screen.y*600+0,800,600,false));
						/*OUT*/ add(new e_Wall(screen.x*800-800,screen.y*600+600,800,600,false));
						/*OUT*/ add(new e_Wall(screen.x*800+0,screen.y*600+600,800,600,false));
						screen.x++;
						vertical=false;
					}			
				}
				
				pscreen = inScreen();
			}
		}
		
		public function inScreen():Point {
			var p:Point = new Point();
			p.x = Math.floor(ref_player.x/800);
			p.y = Math.floor(ref_player.y/600);
			return p;
		}
	}
}
